include \masm32\include\masm32rt.inc
.586
include \masm32\macros\clock_counters.asm

COUNT1      EQU 100
SKIP1       EQU 5
COUNT2      EQU 100 
SKIP2       EQU 5
COUNT3      EQU 100
SKIP3       EQU 5
REPS        EQU 1000
PRIORITY    EQU IDLE_PRIORITY_CLASS

; 
counter_initialization

.data
align 8

.code
start:
    print "Mean clock counts:",13,10
    
    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
    counter1_end
    print   left$(real8$(__fp_result),5)
    print " cycles, no code",13,10

    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
    repeat REPS
        nop
    endm
    counter1_end
    print   left$(real8$(__fp_result),5)
    print " cycles, nop",13,10

    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
    repeat REPS
        nops    4
    endm
    counter1_end
    print   left$(real8$(__fp_result),5)
    print" cycles, nops 4",13,10

    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
    repeat REPS
        bswap eax
    endm
    counter1_end
    print   left$(real8$(__fp_result),5)
    print " cycles, bswap eax",13,10

    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
    repeat REPS
        mov eax,1
    endm
    counter1_end
    print   left$(real8$(__fp_result),5)
    print " cycles, mov eax, 1",13,10

    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
    repeat REPS
        movzx eax,cl
    endm
    counter1_end
    print   left$(real8$(__fp_result),5)
    print " cycles, movzx eax,cl",13,10

    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
     repeat REPS
       add eax,1
    endm
    counter1_end
    print   left$(real8$(__fp_result),5)
    print " cycles, add eax, 1",13,10

    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
     repeat REPS
       cmp eax,7fffffffh
    endm
    counter1_end
    print   left$(real8$(__fp_result),5)
    print " cycles, cmp eax,7fffffffh",13,10

    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
    repeat REPS
        adc eax,1
    endm
    counter1_end
    print   left$(real8$(__fp_result),5)
    print " cycles, adc eax, 1",13,10

    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
    repeat REPS
        ror eax,8
    endm
    counter1_end
    print   left$(real8$(__fp_result),5)
    print " cycles, ror eax, 8",13,10

    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
    repeat REPS
        rcr eax,8
    endm
    counter1_end
    print   left$(real8$(__fp_result),5)
    print " cycles, rcr eax, 8",13,10

    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
     repeat REPS
       mul ebx
    endm
    counter1_end
    print   left$(real8$(__fp_result),5)
    print " cycles, mul ebx",13,10

    counter1_begin COUNT1, SKIP1, REPS, PRIORITY
    repeat REPS
        xor edx,edx
        div ebx
    endm
    counter1_end
    print   left$(real8$(__fp_result),5)
    print " cycles, xor edx,edx : div ebx",13,10,10


   print "Minimum clock counts:",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, no code",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
    repeat REPS
        nop
    endm
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, nop",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
    repeat REPS
        nops 4
    endm
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, nops 4",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
    repeat REPS
        bswap eax
    endm
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, bswap eax",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
    repeat REPS
        mov eax,1
    endm
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, mov eax, 1",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
    repeat REPS
        movzx eax,cl
    endm
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, movzx eax,cl",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
    repeat REPS
        add eax,1
    endm
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, add eax, 1",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
     repeat REPS
       cmp eax,7fffffffh
    endm
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, cmp eax,7fffffffh",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
    repeat REPS
        adc eax,1
    endm
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, adc eax, 1",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
    repeat REPS
        ror eax,8
    endm
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, ror eax, 8",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
    repeat REPS
        rcr eax,8
    endm
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, rcr eax, 8",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
    repeat REPS
        mul ebx
    endm
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, mul ebx",13,10

    counter2_begin COUNT2, SKIP2, REPS, PRIORITY
    repeat REPS
        xor edx,edx
        div ebx
    endm
    counter2_end
    print   left$(real8$(__fp_result),5)
    print " cycles, xor edx,edx : div ebx",13,10,10

    print "Adjunct mean clock counts:",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
    counter3_end
    print   left$(real8$(__fp_result),5)
   print " cycles, no code",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
    repeat REPS
        nop
    endm
    counter3_end
    print   left$(real8$(__fp_result),5)
    print " cycles, nop",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
    repeat REPS
        nops 4
    endm
    counter3_end
    print   left$(real8$(__fp_result),5)
    print " cycles, nops 4",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
    repeat REPS
        bswap eax
    endm
    counter3_end
    print   left$(real8$(__fp_result),5)
    print " cycles, bswap eax",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
    repeat REPS
        mov eax,1
    endm
    counter3_end
    print   left$(real8$(__fp_result),5)
    print " cycles, mov eax, 1",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
    repeat REPS
        movzx eax,cl
    endm
    counter3_end
    print   left$(real8$(__fp_result),5)
    print " cycles, movzx eax,cl",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
    repeat REPS
        add eax,1
    endm
    counter3_end
    print   left$(real8$(__fp_result),5)
    print " cycles, add eax, 1",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
     repeat REPS
       cmp eax,7fffffffh
    endm
    counter3_end
    print   left$(real8$(__fp_result),5)
    print " cycles, cmp eax,7fffffffh",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
    repeat REPS
        adc eax,1
    endm
    counter3_end
    print   left$(real8$(__fp_result),5)
    print " cycles, adc eax, 1",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
    repeat REPS
        ror eax,8
    endm
    counter3_end
    print   left$(real8$(__fp_result),5)
    print " cycles, ror eax, 8",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
    repeat REPS
        rcr eax,8
    endm
    counter3_end
    print   left$(real8$(__fp_result),5)
    print " cycles, rcr eax, 8",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
    repeat REPS
        mul ebx
    endm
    counter3_end
    print   left$(real8$(__fp_result),5)
    print " cycles, mul ebx",13,10

    counter3_begin COUNT3, SKIP3, REPS, PRIORITY
    repeat REPS
        xor edx,edx
        div ebx
     endm
   counter3_end
    print   left$(real8$(__fp_result),5)
    print " cycles, xor edx,edx : div ebx",13,10,10
    
    inkey "Press any key to exit..."
    exit
; 

End     start




