
include \masm32\include\masm32rt.inc
include agner_macros.asm
.686

NUMTESTS = 256		; set number of times to run test
rand      proto :DWORD

; ---------------------- DATA SEGMENT ----------------------
.data
ALIGN 8
results dq	NUMTESTS	dup(?)
seed    dd  123
; ---------------------- code segment ----------------------
.code
start:
    print   chr$("Agner Fog's Clock Counter for MASM32",13,10)
    agner_begin offset results

;Enabling the following instruction undoes the cyclic dependency.
;A constant 532 result corresponds to 53.2/iteration.
;    mov seed,123

       repeat 10
               invoke rand,256
       endm
    agner_finish

    print chr$("Overhead: ")
    print str$(DWORD PTR overhead)
    print chr$(13,10,10,"Clock counts:")
    
    mov esi,offset results
    mov ebx,0
    mov ecx,0
LL: mov edi,[esi+ebx]
    mov edx,15
    and edx,ecx
    push    ecx
    jnz @F
    print chr$(13,10)           ;new line
    
@@: print str$(edi),"  "
    add ebx,8
    pop ecx
    add ecx,1
    cmp ecx,NUMTESTS
    jb LL    

    print chr$(13,10)
    inkey   "Press any key to exit..."
    exit

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 4
rand proc base:DWORD
    mov ecx, seed
    mov edx, ecx
    sar edx, 16
    imul edx, edx, 16807
    movzx eax, cx
    imul eax, eax, 16807
    mov ecx, edx
    shr edx, 15
    and ecx, 32767
    sal ecx, 16
    add eax, ecx
    add eax, edx
    js  L2
  L1:
    xor edx, edx
    mov seed,eax
    div dword ptr[esp+4]
    mov eax, edx

    ret 4
  L2:
    sub eax, 2147483647
    jmp L1
rand  endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
        
End     start




